<script setup>
import * as inputEnums from '@/app/enums/input';
import Input from '@/app/components/crud/particles/Input.vue';

import { sendRequest } from './scripts/sendRequest';
</script>

<script>
export default {
    data() {
        return {
            inputs: {
                brand_id: {
                    label: this.__('fields->brand_id'),
                    name: 'brand_id',
                    type: inputEnums.types.select2Ajax,
                    select2Value: 'product.brand.name',
                    options: {
                        path: 'product/brand',
                        field: 'name',
                        onChange: ($el) => {
                            $('[name="product_id"]').val('').trigger('change');
                            $('[name="variation_id"]').val('').trigger('change');
                        },
                    },
                    wrapperSize: inputEnums.wrapperSizes.md,
                },
                product_id: {
                    label: this.__('fields->product_id'),
                    name: 'product_id',
                    type: inputEnums.types.select2Ajax,
                    select2Value: 'product.model_number',
                    options: {
                        path: 'product/product',
                        query: ($el) => {
                            let brandId = $('[name="brand_id"]').val();

                            return brandId
                                ? {
                                      'filter[brand_id]': brandId,
                                  }
                                : {};
                        },
                        field: 'model_number',
                        onChange: ($el) => {
                            $('[name="variation_id"]').attr('disabled', $el.val() === '');
                        },
                    },
                    wrapperSize: inputEnums.wrapperSizes.md,
                },
                variation_id: {
                    label: this.__('fields->variation_id'),
                    name: 'variation_id',
                    type: inputEnums.types.select2Ajax,
                    select2Value: 'variation.name',
                    options: {
                        path: 'product/variation',
                        query: ($el) => ({
                            'with[0]': 'options',
                            'filter[product_id]': $('[name*="product_id"]').val(),
                        }),
                        field: 'options.name',
                        valueField: 'name',
                    },
                    wrapperSize: inputEnums.wrapperSizes.md,
                },
            },
        };
    },
    methods: {
        submit(event) {
            sendRequest(this, event, 'exchange/excel/export/product-variation', (formData) => {
                return 'Product variationss (' + formData.get('date_from') + ' - ' + formData.get('date_to') + ').xlsx';
            });
        },
    },
};
</script>

<template>
    <div class="card card-primary">
        <div class="card-header card-primary">
            {{
                __('Экспорт: :type', {
                    type: __('Вариации продуктов'),
                })
            }}
        </div>

        <div class="card-body">
            <form @submit.prevent="submit">
                <div class="row">
                    <Input :item="inputs.brand_id" />
                    <Input :item="inputs.product_id" />
                    <Input :item="inputs.variation_id" />

                    <Input
                        :item="{
                            label: __('fields->date_from'),
                            name: 'date_from',
                            type: inputEnums.types.date,
                            options: {},
                            wrapperSize: inputEnums.wrapperSizes.lg,
                        }"
                    />
                    <Input
                        :item="{
                            label: __('fields->date_to'),
                            name: 'date_to',
                            type: inputEnums.types.date,
                            options: {},
                            wrapperSize: inputEnums.wrapperSizes.lg,
                        }"
                    />
                </div>

                <button type="submit" class="btn btn-success btn-block">
                    {{ __('Экспортировать') }}
                </button>
            </form>
        </div>
    </div>
</template>
